import cv2 as cv
import os
import numpy as np

class image_tools(object):

    def __init__(self):
        self.image_dir = r'D:\pic3'
        self.save_image_path = r'D:\pic4'

    def get_image_paths(self):
        dirs = os.listdir(self.image_dir)
        return [os.path.join(self.image_dir,dirs[i]) for i in range(len(dirs))]


    def valid(self,image, x, y):
        if x < 0 or x >= image.shape[0] or y < 0 or y >= image.shape[1]:
            return False
        else:
            return True

    # 判断某个点是否为噪点，after_table_b用于描点画图，可以改变level以调节去噪深度
    def clear_noise_pixel_binary(self,image, x, y, after_table_b, level):
        now = image[x, y]
        flag = 0
        for i in range(-1, 2):
            for j in range(-1, 2):
                if i == 0 and j == 0:
                    continue
                if self.valid(image, x + i, y + j):
                    if image[x + i, y + j] == 0:
                        flag += 1  # 计算该点周围黑色点的数量
        # print(flag)
        if now == 0 and flag < level:
            after_table_b[x, y] = 255  # 去除操作，若该点为黑点，且周围黑点的数量小于level，则将该点变为白点
        elif now == 1 and flag >= 4:
            after_table_b[x, y] = 0  # 补充操作，若该点为白点，且周围黑点的数量大于等于4，则将该点变为黑点
        else:
            after_table_b[x, y] = now
    #清除黑线
    def clear_black(self,image, x, y, new_image):
        now = image[x, y]
        # print(now)
        if now[0] <= 30 and now[1] <= 30 and now[2] <= 30:
            new_image[x, y] = (255, 255, 255)
        else:
            new_image[x, y] = now

    '''将验证码分成4张图片'''
    def image_splite_one_image(self,image_path):
        img = cv.imread(image_path)
        h, w, ch = img.shape
        '''去除黑线'''
        no_black_line_img = np.zeros(shape=(h, w, 3), dtype=img.dtype)
        for row in range(h):
            for col in range(w):
                self.clear_black(img, row, col, no_black_line_img)
        '''转为灰度'''
        gray_image = cv.cvtColor(no_black_line_img, cv.COLOR_BGR2GRAY)
        '''二值化'''
        T = cv.mean(gray_image)[0]
        binary_image = np.zeros(shape=gray_image.shape, dtype=gray_image.dtype)
        for row in range(h):
            for col in range(w):
                px = gray_image[row, col]
                if px > T:
                    binary_image[row, col] = 255
                else:
                    binary_image[row, col] = 0
        '''去除椒盐噪音，不建议用中值滤波'''
        pic = np.zeros(binary_image.shape, dtype=binary_image.dtype)
        for row in range(h):
            for col in range(w):
                self.clear_noise_pixel_binary(binary_image, row, col, pic, 3)
        return pic[0:20, 12:28],pic[0:20,28:44],pic[0:20,44:60],pic[0:20,60:76]

    def image_spilt_all(self):
        image_dirs = self.get_image_paths()
        for name,image_path in enumerate(image_dirs):
            pic1,pic2,pic3,pic4 = self.image_splite_one_image(image_path)
            cv.imwrite(self.save_image_path + '\\' + str(name) + '_' + '1' + '.jpg', pic1)
            cv.imwrite(self.save_image_path + '\\' + str(name) + '_' + '2' + '.jpg', pic2)
            cv.imwrite(self.save_image_path + '\\' + str(name) + '_' + '3' + '.jpg', pic3)
            cv.imwrite(self.save_image_path + '\\' + str(name) + '_' + '4' + '.jpg', pic4)
            cv.waitKey(0)
            cv.destroyAllWindows()

    def morphology(self,path):
        src = cv.imread(path)
        k = np.zeros((1,1),np.uint8)
        # res = cv.morphologyEx(src,cv.MORPH_CLOSE,k,iterations=3)
        res = cv.erode(src,k)
        cv.imshow('src', src)
        cv.imshow('res',res)
        cv.waitKey(0)
        cv.destroyAllWindows()








if __name__ == '__main__':
    # tool = image_tool()
    # tool.image_spilt()
    # tool.morphology(r'D:\pic4\6_3.jpg')
    src = cv.imread(r'D:\pic4\6_3.jpg')
    # print(src)

