import requests
import time
import cv2 as cv
import numpy as np
from bs4 import BeautifulSoup

from beautifulsoup.image_tools import image_tools


class parameters():

    image_tool = image_tools()
    #验证码模型识别后对应的结果
    yzm_dict = {0: '0', 1: 'a', 2: '2', 3: '3', 4: '4', 5: '5',
                6: '6', 7: '7', 8: '8', 9: '9', 10: 'b', 11: 'c',
                12: 'd', 13: 'e', 14: 'f', 15: 'g', 16: 'h',
                17: 'i', 18: 'j', 19: 'k', 20: 'm', 21: 'n',
                22: 'o', 23: 'p', 24: 'q', 25: 'r', 26: 's',
                27: 't', 28: 'u', 29: 'v', 30: 'w', 31: 'x', 32: 'y', 33: 'z'}
    #公司对应的企业编号
    company_qybh = {'杭州长运运输集团有限公司':'33010000062325',
                    '杭州长运西北汽车客运有限公司':'33010000002360',
                    '杭州长运东南汽车客运有限公司':'33010000001401',
                    '杭州长运客运旅游有限公司':'33010000001412',
                    '浙江新干线快速客运有限公司':'33010000006485',
                    '杭州长运旅游有限公司':'33010000001410',
                    '杭州长运交通客运旅游有限公司':'33010000001399',
                    '杭州巴士运输有限公司':'33010000015545',
                    '杭州城际旅游客运有限公司':'33010000000455',
                    '浙江杭舟快速客运有限公司':'33010000006926',
                    '杭州长三角旅游客运有限公司':'33010000107665',
                    '杭州德清公共交通有限公司':'33010000002381',
                    '杭州长运三运运输有限公司':'33010000007447',
                    '杭州长运快运物流有限公司':'33010000026445',
                    '杭州长运货的有限公司':'33010000028945',
                    '浙江长运物流股份有限公司':'33010000069705'}

    def __init__(self,username,password):
        self.username = username
        self.password = password
        self.login_url = "http://122.224.89.228:9003/zdc/loginNomal.spr"
        self.img_url = "http://122.224.89.228:9003/zdc/VerifyCodeServlet?temp=3166"
        self.yzm_path = r'/root/javi/yzm_pic/yzm.jpg'
        # self.yzm_path = r'C:/Users/MSI-NB/Desktop/model/yzm.jpg'
        self.yzm_model_path = r'/root/javi/model/yzm_model.pb'
        # self.yzm_model_path = r'C:/Users/MSI-NB/Desktop/model/yzm_model.pb'
        self.session = self.get_session_id()
        self.driver_url = 'http://122.224.89.228:9003/zdc/jsrcx.spr?act=toList'
        self.driver_excel = r'C:\Users\MSI-NB\Desktop\数据文档\drivers_test.xlsx'
        self.driver_column =['证件号码', '档案编号', '驾驶人照片', '证件名称', '姓名', '性别', '出生日期', '准驾车型', '发证机关', '驾驶证状态', '初次领证日期', '下一体检日期', '初次发证机关',
             '驾证期限', '有效期始', '有效期至', '累计积分', '超分日期', '下一清分日期', '证芯编号', '从业日期', '记录状态', '审验日期', '管理部门', '驾校名称']
        self.vio_excel = r'C:\Users\MSI-NB\Desktop\数据文档\vio_test.xlsx'
        self.vio_column = ['单位名称','相关车辆信息','驾驶证号','违法时间','姓名','违法内容']


    def get_session_id(self):
        print('【开始认证session】')
        response = requests.get(self.login_url) #请求登录，获取session
        set_session = response.headers.get("Set-Cookie")
        session_id = set_session.split(";")[0].split("=")[1] #此时的session未认证
        headers = {
            "Cookie": "JSESSIONID=" + session_id
        }
        status = self.retry_identify(headers)
        if status == 1:
            return session_id
        else:
            return None

    #当前识别验证码的模型准确率为97%,如果识别错误则重试
    def retry_identify(self,headers):
        time = 0
        while True:
            yzm = self.identify_session(headers)
            print('当前验证码 = ',yzm)
            data = {
                'YHDH': self.username,
                'MM': self.password,
                'YZM': yzm
            }
            #发送验证请求
            login_response = requests.post(self.login_url,data=data,headers=headers).content
            # print(login_response)
            bsp = BeautifulSoup(login_response, 'html.parser')
            print(bsp.title.string)
            if bsp.title.string == 'Title':
                print('【验证码识别成功】')
                return 1

            # if bsp.title.string == '道路交通安全管理客(货)运企业监管服务平台':
            #     print('【账号密码有误】')
            #     return 0
            time += 1
            if time > 5:
                break
            print('【验证码识别失败，正在重新获取验证码】')

    #使用深度学习模型进行验证码识别并登录
    def  identify_session(self,headers):
        pictures = None
        flag = True #一直抓取验证码，直到抓取成功
        while flag:
            response_yzm = requests.get(self.img_url, headers=headers)
            img = open(self.yzm_path, 'wb')
            img.write(response_yzm.content)
            img.flush()
            try:
                # 识别验证码 对验证码图片进行预处理，分成4张图片，每个进行预测
                pictures = self.image_tool.image_splite_one_image(self.yzm_path)
                flag = False
            except Exception:
                print('【当前抓取的验证码有误，重新抓取中】')

        #加载模型
        net = cv.dnn.readNetFromTensorflow(self.yzm_model_path)
        yzm = ''
        for pic in list(pictures):
            pic = pic.astype('float32')
            pic = pic / 255
            image_input = cv.dnn.blobFromImage(pic, size=(16, 20), swapRB=True, crop=False)
            net.setInput(image_input)
            result = net.forward()
            index = np.argmax(result[0], axis=0)
            yzm += self.yzm_dict[index]
        return yzm

    def create_one_page_parameter(self):
        return {'act': 'toList'}

    def create_another_page_parameter(self,page_id):
        return {'act': 'toList','currentPage': page_id}

    def create_one_page_header(self):
        return {
            'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'zh-CN,zh-TW;q=0.9,zh;q=0.8,en-US;q=0.7,en;q=0.6',
            'Connection': 'keep-alive',
            'Cookie': 'yhdh=79667012-1; JSESSIONID={}; td_cookie=18446744073013412890'.format(self.session),
            'Host': '122.224.89.228:9003',
            'Referer': 'http://122.224.89.228:9003/zdc/navigate.spr?act=showleftmenu&priId=A60000',
            'Upgrade-Insecure-Requests': '1',
            'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.183 Safari/537.36'
        }

    def create_another_page_header(self):
        return {
            'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'zh-CN,zh-TW;q=0.9,zh;q=0.8,en-US;q=0.7,en;q=0.6',
            'Cache-Control': 'max-age=0',
            'Connection': 'keep-alive',
            'Content-Length': '14',
            'Content-Type': 'application/x-www-form-urlencoded',
            'Cookie': 'yhdh=79667012-1; JSESSIONID={}; td_cookie=18446744073014099599'.format(self.session),
            'Host': '122.224.89.228:9003',
            'Origin': 'http://122.224.89.228:9003',
            'Referer': 'http://122.224.89.228:9003/zdc/jsrcx.spr?act=toList',
            'Upgrade-Insecure-Requests': '1',
            'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.183 Safari/537.36'
        }

    def create_id_header(self):
        return {'Accept':'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9',
                'Accept-Encoding':'gzip, deflate',
                'Accept-Language':'zh-CN,zh-TW;q=0.9,zh;q=0.8,en-US;q=0.7,en;q=0.6',
                'Connection':'keep-alive',
                'Cookie':'yhdh=79667012-1; JSESSIONID={}; td_cookie=18446744073027431086'.format(self.session),
                'Host':'122.224.89.228:9003',
                'Referer':'http://122.224.89.228:9003/zdc/jsrcx.spr?act=toList',
                'Upgrade-Insecure-Requests':'1',
                'User-Agent':'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.183 Safari/537.36'
                }
    def create_id_url(self,id):
        return 'http://122.224.89.228:9003/zdc/jsrcx.spr?act=toDetaile&xh={}&isdel='.format(str(id))

    def create_vio_url(self):
        return 'http://122.224.89.228:9003/zdc/dwr/call/plaincall/DrvInfServiceJS.queryJsrwf.dwr'

    def create_vio_header(self,time):
        return {
            'Accept': '*/*',
            'Accept-Encoding': 'gzip, deflate',
            'Accept-Language': 'zh-CN,zh-TW;q=0.9,zh;q=0.8,en-US;q=0.7,en;q=0.6',
            'Connection': 'keep-alive',
            'Content-Length': '325',
            'Content-Type': 'text/plain',
            'Cookie': 'JSESSIONID={}; yhdh=79667012-1'.format(self.session),
            'Host': '122.224.89.228:9003',
            'Origin': 'http://122.224.89.228:9003',
            'Referer': 'http://122.224.89.228:9003/zdc/jsrcx.spr?act=toJsrwf&_=1604887361609&tjsj={}&qybh=33010000002360'.format(time),
            'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.183 Safari/537.36'
        }

    def create_vio_parameter(self,time,company_name):
        return {
            'scriptSessionId':'',
            'callCount':'1',
            'windowName':'',
            'c0-scriptName':'DrvInfServiceJS',
            'c0-methodName':'queryJsrwf',
            'c0-id':'0',
            # 'c0-param0':'string:33010000002360',
            'c0-param0':self.company_qybh[company_name],
            'c0-param1':'string:{}'.format(time),
            'batchId':'1',
            'page':'%2Fzdc%2Fjsrcx.spr%3Fact%3DtoJsrwf%26_%3D1604887361609%26tjsj%3D{}%26qybh%3D33010000002360'.format(time),
            'httpSessionId':''
        }

if __name__ == '__main__':
    p = parameters()
    id = p.get_session_id()





