import tensorflow as tf
import numpy as np
from tensorflow import keras
import glob
import matplotlib.pyplot as plt

#%%
# 验证码图片地址
dirs = r'D:/pic2/*'
paths = glob.glob(dirs)
# print(paths)
dict = {'0':0,'a':1,'2':2,'3':3,'4':4,'5':5,
        '6':6,'7':7,'8':8,'9':9,'b':10,'c':11,
        'd':12,'e':13,'f':14,'g':15,'h':16,'i':17,
        'j':18,'k':19,'m':20,'n':21,'o':22,'p':23,
        'q':24,'r':25,'s':26,'t':27,'u':28,'v':29,
        'w':30,'x':31,'y':32,'z':33}
all_path = []
labels = []
for path_dir in paths:
    image_path = glob.glob(path_dir+"\\*")
    all_path.extend(image_path)
    labels.extend([path_dir[-1] for p in image_path])
all_label = [dict[label] for label in labels]

# print(all_path)
# print(all_label)
total = len(all_path)

#%%

dict2 = {value: key for key, value in dict.items()}
print(dict2)

#%%

def load_pic(path):
    image_binary = tf.io.read_file(path)
    image_tensor = tf.image.decode_jpeg(image_binary)
    # image_tensor = tf.image.random_flip_left_right(image_tensor)
    image_tensor = tf.cast(image_tensor,tf.float32)
    image_tensor = image_tensor / 255
    return image_tensor
# print(all_path[4])
# print(all_label[4])
# tensor = load_pic(all_path[4])
# print(tensor.shape)
# plt.imshow(tf.keras.preprocessing.image.array_to_img(tensor))
# plt.show()

#%%

np.random.seed(2020)
random_index = np.random.permutation(total)
image_dataset = np.array([load_pic(path) for path in all_path])
image_dataset = image_dataset[random_index]
label_dataset = tf.keras.utils.to_categorical(np.array(all_label))
label_dataset = label_dataset[random_index]

#%% 分训练集和测试集

train_total = int(total * 0.8)
test_total = total - train_total
train_ds = image_dataset[0:train_total]
train_label = label_dataset[0:train_total]
test_ds = image_dataset[train_total:]
test_label = label_dataset[train_total:]

#%%

model = tf.keras.Sequential()
model.add(tf.keras.layers.Conv2D(128,(3,3),input_shape=(20,16,1),activation='relu',padding='same'))
model.add(tf.keras.layers.Conv2D(64,(3,3),activation='relu',padding='same'))
model.add(tf.keras.layers.Conv2D(64,(2,2),activation='relu',padding='same'))
model.add(tf.keras.layers.GlobalAveragePooling2D())
model.add(tf.keras.layers.Dense(128,activation='relu'))
model.add(tf.keras.layers.Dense(64,activation='relu'))
model.add(tf.keras.layers.Dense(34,activation='softmax'))
# model.summary()

#%%

optimizer = tf.keras.optimizers.Adam(learning_rate=0.001)
model.compile(optimizer=optimizer,
              loss='categorical_crossentropy',
              metrics=['acc'])
model.fit(x=train_ds,
          y=train_label,
          epochs=100,
          validation_data=(test_ds,test_label))
model.save(r'C:\Users\MSI-NB\Desktop\model\yzm_model.h5')